#!/usr/bin/python
#Socket client example in python
 
import socket   #for sockets
import sys  #for exit
import time
import os
import subprocess
import httplib
import pymodbus
from pymodbus.client.sync import ModbusTcpClient
from email.mime.text import MIMEText
import smtplib
import sys


host = 'RPIEBUS'
remote_ip = '192.168.xxx.xxx'
port = 8888
hm_host = 'RaspberryMatic'
hm_ip = '192.168.xxx.xxx'
hm_port = 8181
mbushost = 'EVCCADV'
mbusinpreg = 112
mbusunit=0xB4 # DEC 180
mbusregcount = 2 # Immer 2 Register lesen
mbus_ip = '192.168.xxx.xxx';
# mail address of the sender
sender = 'xxxx@xxxxx.xx'
# fully qualified domain name of the mail server
smtpserver = 'xxxx.xxxx:xxx'
# username for the SMTP authentication
smtpusername = 'xxxx'
# password for the SMTP authentication
smtppassword = 'xxxxx'
# use TLS encryption for the connection
usetls = True
emailgesendet = True

#
# function to send a mail
#
def sendmail(recipient,subject,content):

  # generate a RFC 2822 message
  msg = MIMEText(content)
  msg['From'] = sender
  msg['To'] = recipient
  msg['Subject'] = subject

  # open SMTP connection
  server = smtplib.SMTP(smtpserver)

  # start TLS encryption
  if usetls:
    server.starttls()

  # login with specified account
  if smtpusername and smtppassword:
    server.login(smtpusername,smtppassword)

  # send generated message
  server.sendmail(sender,recipient,msg.as_string())

  # close SMTP connection
  server.quit()




operates = ( 'KF', 'SF', 'ATM', 'AT_MIN', 'AT_MAX', 'TWSSP1_24h_MIN', 'TWSSP1_24h_MAX', 'TWSSP2_24h_MIN', 'TWSSP2_24h_MAX', 'TK1_24h_MIN', 'TK1_24h_MAX', 'SP1', 'VF1', 'SP2', 'VF2', 'PF', 'STH_1', 'STH_2', 'STHG', 'BBH', 'BBH2', 'BST', 'NBH', 'RLF', 'DFG', 'SM2_E', 'SM2_T')
suboperates = ( 'FLA', 'SL', 'SET', 'SEG', 'SKP1', '3WUV', 'SFK1', 'SFS1', 'SFS2' )
# Die Reihenfolge der Werte in suboperates muss der Reihenfolge der Werte in operates entsprechen.
mbusoperates = ('CURI1', 'CURI2', 'CURI3', 'ENCHSEQ', 'ENTOT', 'ENACT')
mbusregisters = (114, 116, 118, 132, 128, 120) # Immmer 2 Register, da 32-Bit Werte, Reihenfolge entsprechend mbusoperates, alles INPUT Registers

value = []
for i in range(100):
    value.append(1)
    value[i] = str(0.0)

oldvalue = []
for i in range(100):
    oldvalue.append(1)
    oldvalue[i] = 0.0

valid = []
for i in range(100):
    valid.append(1)
    valid[i] = False

changed = []
for i in range(100):
    changed.append(1)
    changed[i] = False


localtime = time.asctime( time.localtime(time.time()) )
print "Local current time :", localtime
print 'EBUS_V5 gestartet'

while 1: 
    #create an INET, STREAMing socket
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    except socket.error:
        print 'Failed to create socket'
        sys.exit()
         
    ##print 'Socket Created'
     
           
    #Connect to remote server
    s.connect((remote_ip , port))
     
    ##print 'Socket Connected to ' + host + ' on ip ' + remote_ip

    #Connect to MBUS server
    try:
        client = ModbusTcpClient(mbus_ip)
    except pymodbus.error:
        localtime = time.asctime( time.localtime(time.time()) )
        print "Local current time :", localtime
        print 'Failed to create MBUS connection'
        sys.exit()
         
    ##print 'MBUS connection Created'
                
    #Connect to MBUS server
    client.connect()
     
    ##print 'MBUS Connected to ' + mbushost + ' on ip ' + mbus_ip


    i = 0
    j = len(operates)
    k = len(operates) + len(suboperates)
    ##print i,j,k
    for oper in operates:
        message = "read " + oper + " \n\r"
        try :
            #Set the whole string
            s.sendall(message)
        except socket.error:
            #Send failed
            print 'EBUS send failed'
            sys.exit()
     
        #print 'EBUS message send successfully :' + oper
     
        #Now receive data
        reply = s.recv(4096)
        reply = reply.lstrip()
        reply = reply.rstrip()
        #print reply
        #print reply.find('ERR')
        if reply.find('ERR'):
            ##print "read " + oper + " -> Wert : " + reply
            value[i] = reply
            valid[i] = True
            if oper == 'SM2_E':
                SM2_E = reply.split(';',6)
                #print SM2_E[0]
                value[j] = SM2_E[0] # -> SL
                valid[j] = True
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1

                #print str(float(SM2_E[1]) + float(SM2_E[2]))
                value[j] = str(float(SM2_E[1]) + float(SM2_E[2])) # -> SET
                valid[j] = 1
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1

                #print str(float(SM2_E[3]) + float(SM2_E[4]) + float(SM2_E[5])*1000)
                value[j] = str(float(SM2_E[3]) + float(SM2_E[4]) + float(SM2_E[5])*1000) # -> SEG
                valid[j] = 1
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1

            if oper == 'SM2_T':
                SM2_T = reply.split(';',8)
                #print SM2_T[0] # -> SPU
                value[j] = str(int(SM2_T[0]) & 1 ) # -> SKP1 Solarpumpe 0/1 = BIT0 von SPU
                valid[j] = 1
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1
                value[j] = str((int(SM2_T[0]) & 2 ) / 2) # -> 3WUV Solarspeicher 1/2 = BIT1 von SPU
                valid[j] = 1
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1

                #print SM2_T[1] # -> ST1 
                #print SM2_T[2]
                value[j] = SM2_T[2] # -> KT                 
                valid[j] = 1
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1

                #print SM2_T[3]
                value[j] = SM2_T[3] # -> SFS1                
                valid[j] = 1
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1
                #print SM2_T[4] # -> T1
                #print SM2_T[5] # -> T2 
                #print SM2_T[6]
                value[j] = SM2_T[6] # -> SFS2                 
                valid[j] = 1
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1
                #print SM2_T[7] # -> T4
                #print SM2_T[8] # -> T5

            if oper == 'STH_1':
                value[j] = str((int(value[i]) & 8 ) / 8) # -> BIT3 von STH_1
                #print "Flamme : " + value[j]
                valid[j] = True
                if value[j] <> oldvalue[j]:
                    oldvalue[j] = value[j]
                    changed[j] = True
                else:
                    changed[j] = False
                j += 1
        else:
            print "Fehler " + oper + " -> : " + reply
            value[i] = '0.0'
            valid[i] = False
        if value[i] <> oldvalue[i]:
            oldvalue[i] = value[i]
            changed[i] = True
        else:
            changed[i] = False
        i += 1

    i = 0
    for oper in mbusoperates:
        register = mbusregisters[i]
        result = client.read_input_registers(register, mbusregcount, unit = mbusunit)
        if result.function_code < 0x80:
            ##print "read register : " + str(register) + " -> Wert : " + str(result.registers[0])
            ##print "read register : " + str(register+1) + " -> Wert : " + str(result.registers[1])
            if (oper == 'ENTOT') or (oper == 'ENACT'):
                value[k] = str(float(result.registers[1] * 0xFFFF + result.registers[0])/100)
                valid[k] = True
            else :
                value[k] = str(float(result.registers[1] * 0xFFFF + result.registers[0])/1000)
                valid[k] = True
            #print "Wert : " + value[k] + " Index : " + str(k)
        else:
            print "Fehler read register : " + str(register) + " -> Wert : " + str(result.registers[0])
            value[k] = '0.0'
            valid[k] = False
        if value[k] <> oldvalue[k]:
            oldvalue[k] = value[k]
            changed[k] = True
        else:
            changed[k] = False
        i += 1
        k += 1


    #Now close socket
    s.close()
    client.close()
    hmconnstatus = False
    hmping = subprocess.call(['ping',hm_ip,'-c1',"-W2", "-q"], stdout=open(os.devnull,'w'))
    #p = subprocess.Popen(['ping',hm_ip,'-c','1',"-W","2"])
    # Windows version p = subprocess.Popen('ping ' + hm_ip)
    # Linux Version p = subprocess.Popen(['ping','127.0.0.1','-c','1',"-W","2"])
    # The -c means that the ping will stop afer 1 package is replied 
    # and the -W 2 is the timelimit
    #p.wait()
    #hmping = p.poll()
    #print hmping
    if hmping == 0:
        if emailgesendet == True:
          localtime = time.asctime( time.localtime(time.time()) )
          print "Local current time :", localtime
          print "IP ist wieder erreichbar"
        hmconnstatus = True
        emailgesendet = False
    else:
        hmconnstatus = False
        if emailgesendet == False:
            localtime = time.asctime( time.localtime(time.time()) )
            print "Local current time :", localtime
            print "IP ist NICHT erreichbar"
            # call sendmail() and generate a new mail with specified subject and content
            sendmail('manfredschuessler@me.com','EBUS_RPI','NTAIL RaspberryMatic nicht per Netzwerk erreichbar.')
            emailgesendet = True

    i = 0
    if hmconnstatus == True:
        #create an INET, STREAMing socket
        conn = httplib.HTTPConnection(hm_ip, hm_port)
        #print 'HM Socket Created'
        for oper in operates + suboperates + mbusoperates:
            if valid[i] == True:
                #print "I : " + str(i) + ", Wert : " + value[i]
                if changed[i] == True:
                    #Send some data to remote server
                    message = "/xy.exe?do=dom.GetObject('WOLF_" + oper + "').State(" + value[i] + ")"
                    try :
                        #Set the whole string
                        #print message
                        conn.request("GET", message)
                    except Exception as e:
                        #Send failed
                        localtime = time.asctime( time.localtime(time.time()) )
                        print "Local current time :", localtime
                        print 'Send failed', type(e)
                        #sys.exit()
                    #time.sleep(1)
                    response = conn.getresponse()
                    #print "Status : " + str(response.status) + " Reason : " + response.reason
                    if response.status <> 200:
                        localtime = time.asctime( time.localtime(time.time()) )
                        print "Local current time :", localtime
                        print "Fehler in der Antwort"
                    ##else:
                        ##print "Erfolgreich gesendet"
                    #data = response.read()
                    #print data
                    #print 'HM Message send successfully'
                    conn.close()
            i += 1
         
    #Now close socket
    conn.close()
    time.sleep(10)
   
